package generated.A0000000B;

/**
 * RMI stub for generated.A00000008.Interface.
 *
 * A stub element has a client remote port "line" through which
 * it connects to the target object. When binding the "line" port
 * to a remote target using a bundle of references, a local stub
 * is only interested in the "rmi" reference.
 *
 * This RMI stub uses "rmi" reference from the reference bundle and always
 * returns itself as the reference to the provided "call" port, because it
 * creates connectors for interface references in bussines methods.
 *
 * Consequently, this element never invalidates its "call" provided port.
 */
@org.objectweb.dsrg.connector.rmi.ConnectorInterface("generated.A0000000C.Wrapper")
public final class RMIStub 
    implements
        org.objectweb.dsrg.connector.ElementLocalServer,
        org.objectweb.dsrg.connector.ElementRemoteClient,
        org.objectweb.dsrg.sofa.examples.logdemo.iface.Log {

    /**
     * Local target of business method invocations.
     */
    protected generated.A00000008.Interface target;

    /**
     * A bundle of remote references to the target of business method
     * invocations.
     */
    protected org.objectweb.dsrg.connector.RemoteRefBundle targetRemoteRef;

     /*
     * Instance of dock connector manager which is responsible for connector
     * units within the dock.
     */
    protected org.objectweb.dsrg.connector.mgr.DockConnectorManager dcm;

    protected org.objectweb.dsrg.connector.mgr.GlobalConnectorManager gcm;

    /*
     * Reference to parent connector unit.
     */
    protected org.objectweb.dsrg.connector.ConnectorUnit parentUnit;

    protected boolean isTopLevel;


    /* **********************************************************************
     * CONSTRUCTORS
     * **********************************************************************/

    public RMIStub (
            org.objectweb.dsrg.connector.ConnectorUnit parentUnit,
            boolean isTopLevel)
        throws org.objectweb.dsrg.connector.ElementLinkException {

        this.parentUnit = parentUnit;
        this.isTopLevel = isTopLevel;

        dcm = org.objectweb.dsrg.connector.mgr.
            DockConnectorManagerHelper.getDockConnectorManager();

        try {
            gcm = org.objectweb.dsrg.connector.mgr.
                GlobalConnectorManagerHelper.getGlobalConnectorManager ();

        } catch (org.objectweb.dsrg.connector.mgr.ConnectorManagerException e) {
            throw new org.objectweb.dsrg.connector.ElementLinkException (e);
        }
    }

    /* **********************************************************************
     * Element Methods
     * **********************************************************************/

	public final String getElementInfo (String indent) {
		StringBuilder result = new StringBuilder ();

		result.append (indent +"Implementation: \"orig_rmi_stub\"\n");

		return result.toString ();
	}


    /* **********************************************************************
     * ElementLocalServer Methods
     * **********************************************************************/

    /**
     * Queries given provided port for a local object reference.
     */
    public Object lookupElPort (String portName)
        throws org.objectweb.dsrg.connector.ElementLinkException {

        if ("call".equals (portName)) {
            /*
             * Always return reference to itself when asked for
             * a reference to the "call" port.
             */
            if (isTopLevel) {
                dcm.reregisterConnectorUnitReference (
                    parentUnit, "call", this);
            }

            return this;

        } else {
            throw new org.objectweb.dsrg.connector.ElementLinkException (
                "Attempt to look up non-existent provided port '"+ portName +"'.");
        }
    }


    /* **********************************************************************
     * ElementRemoteClient Methods
     * **********************************************************************/

    /**
     * Binds a remote client port of this element to a remote server port
     * using a bundle of named references. This RMI stub has one remote
     * client port "line" and requires the reference bundle to contain a
     * reference named "rmi" which can be then resolved to a local
     * object reference.
     */
    public void bindElRemotePort (
            String portName,
            org.objectweb.dsrg.connector.RemoteRefBundle refBundle)
        throws org.objectweb.dsrg.connector.ElementLinkException {

        if ("line".equals(portName)) {
            org.objectweb.dsrg.connector.RemoteRef rmiRef;

            rmiRef = refBundle.getRef ("rmi");
            if (rmiRef != null) {

                try {
                    String GCMHost = System.getProperty ("connector.gcm.rmihost");
        			String GCMPort = System.getProperty ("connector.gcm.rmiport", "2008"); 
        			if (GCMHost == null) {
			            throw new org.objectweb.dsrg.connector.ElementLinkException (
			                "Property 'connector.gcm.rmihost' must be set to a location of Global Connector Manager.");
			        }
        			
                	java.rmi.registry.Registry registry = java.rmi.registry.
                		LocateRegistry.getRegistry(GCMHost, Integer.parseInt(GCMPort));
                	target = (generated.A00000008.Interface)registry.lookup (rmiRef.stringifiedRef);

                } catch (java.rmi.RemoteException e) {
                    throw new org.objectweb.dsrg.connector.ElementLinkException (e);
                } catch (java.rmi.NotBoundException e) {
                    throw new org.objectweb.dsrg.connector.ElementLinkException (e);
                }

                targetRemoteRef = refBundle;

            } else {
                target = null;
            }

        } else {
            throw new org.objectweb.dsrg.connector.ElementLinkException (
                "Attempt to bind non-existent remote port '"+ portName +"'.");
        }
    }


    /**
     * Unbinds a given remote client port of this element
     * from a remote server port.
     */
    public void unbindElRemotePort (String portName)
        throws org.objectweb.dsrg.connector.ElementLinkException {

        if ("line".equals (portName)) {
            target = null;
            targetRemoteRef = null;

        } else {
            throw new org.objectweb.dsrg.connector.ElementLinkException (
                "Attempt to unbind non-existent remote port '"+ portName +"'.");
        }
    }


    /**
     * Queries given remote client port of this element
     * for its target reference bundle.
     */
    public org.objectweb.dsrg.connector.RemoteRefBundle getElRemoteTarget (
            String portName)
        throws org.objectweb.dsrg.connector.ElementLinkException {

        if ("line".equals (portName)) {
            return targetRemoteRef;

        } else {
            throw new org.objectweb.dsrg.connector.ElementLinkException (
                "Attempt to query target of non-existent remote port '"+ portName +"'.");
        }
    }


    /* **********************************************************************
     * generated.A00000008.Interface Methods
     * **********************************************************************/

	public void log (java.lang.String arg0) {

		org.objectweb.dsrg.connector.rmi.RMIObjectEncoder rmiEncoder = new org.objectweb.dsrg.connector.rmi.RMIObjectEncoder();

		try {
	this.target.log (rmiEncoder.adaptObject(arg0),org.objectweb.dsrg.sofa.SOFAThreadHelper.getCallContext());
		} catch (java.rmi.RemoteException exc) {
			throw new org.objectweb.dsrg.connector.ConnectorTransportException (exc);
		} catch (org.objectweb.dsrg.connector.rmi.RMIObjectAdaptorException e) {
			throw new org.objectweb.dsrg.connector.ConnectorTransportException (e);
		}

		return;
	}


}
