package generated.A0000000I;

import javax.jms.Connection;
import javax.jms.Destination;
import javax.jms.JMSException;
import javax.jms.Message;
import javax.jms.MessageConsumer;
import javax.jms.MessageListener;
import javax.jms.MessageProducer;
import javax.jms.Session;
import javax.jms.ObjectMessage;
import java.io.Serializable;

import org.apache.activemq.ActiveMQConnection;
import org.apache.activemq.ActiveMQConnectionFactory;

public final class MessagingSendRecv 
    implements
        org.objectweb.dsrg.connector.ElementLocalServer,
        org.objectweb.dsrg.connector.ElementLocalClient,
        org.objectweb.dsrg.connector.ElementRemoteClient,
        org.objectweb.dsrg.connector.ReconfigurableElement,
        org.objectweb.dsrg.connector.messaging.MessageSender,
        MessageListener {
	
	Connection connection;
	Session session;
	MessageConsumer consumer;
	MessageProducer producer;
	
	org.objectweb.dsrg.connector.messaging.MessageReceiver client;

    /**
     * A bundle of remote references to the target of business method
     * invocations.
     */
    protected org.objectweb.dsrg.connector.RemoteRefBundle targetRemoteRef;

    /*
     * Instance of dock connector manager which is responsible for connector
     * units within the dock.
     */
    protected org.objectweb.dsrg.connector.mgr.DockConnectorManager dcm;

    /*
     * Reference to parent connector unit.
     */
    protected org.objectweb.dsrg.connector.ConnectorUnit parentUnit;

    protected boolean isTopLevel;

    /**
     * Reconfiguration request handler.
     */
    protected org.objectweb.dsrg.connector.ReconfigurationHandler reconfigurationHandler;


    /* **********************************************************************
     * CONSTRUCTORS
     * **********************************************************************/

    /**
     * Constructs a new local stub element.
     */
    public MessagingSendRecv (
            org.objectweb.dsrg.connector.ConnectorUnit parentUnit,
            boolean isTopLevel) {

        this.parentUnit = parentUnit;
        this.isTopLevel = isTopLevel;

        dcm = org.objectweb.dsrg.connector.mgr.
            DockConnectorManagerHelper.getDockConnectorManager();
    }


    /* **********************************************************************
     * Element Methods
     * **********************************************************************/

	public final String getElementInfo (String indent) { return ""; }


    /**
     * Sets the reconfiguration handler.
     */
    public final void setElReconfigurationHandler (
        org.objectweb.dsrg.connector.ReconfigurationHandler reconfigurationHandler) {

        this.reconfigurationHandler = reconfigurationHandler;
    }


    /* **********************************************************************
     * ElementLocalServer Methods
     * **********************************************************************/

    /**
     * Queries given provided port for a local object reference.
     */
    public Object lookupElPort (String portName)
        throws org.objectweb.dsrg.connector.ElementLinkException {

        if ("send".equals (portName)) {

            if (isTopLevel) {
                dcm.reregisterConnectorUnitReference (
                    parentUnit, "send", this);
            }

            return this;

        } else {
            throw new org.objectweb.dsrg.connector.ElementLinkException (
                "Attempt to look up non-existent provided port '"+ portName +"'.");
        }
    }
    
    /* **********************************************************************
     * ElementLocalClient Methods
     * **********************************************************************/

    /**
     * Binds a given required port of this element to a target object using
     * a local object reference.
     *
     * TODO: Handle reconfiguration.
     */
    public void bindElPort (String portName, Object target)
        throws org.objectweb.dsrg.connector.ElementLinkException {

        if ("recv".equals (portName)) {
            this.client = (org.objectweb.dsrg.connector.messaging.MessageReceiver) target;
			checkAndSetConsumer();
        } else {
            throw new org.objectweb.dsrg.connector.ElementLinkException (
                "Attempt to bind non-existent required port '"+ portName +"'.");
        }
    }
    
    /**
     * Unbinds a given required port of this element from its target.
     */
    public void unbindElPort (String portName)
        throws org.objectweb.dsrg.connector.ElementLinkException {

        if ("recv".equals (portName)) {
            try {
				this.client = null;
				if (consumer != null)
					consumer.setMessageListener(null);
			} catch (JMSException e) {
				throw new org.objectweb.dsrg.connector.ElementLinkException (e);
			}
        } else {
            throw new org.objectweb.dsrg.connector.ElementLinkException (
                "Attempt to unbind non-existent required port '"+ portName +"'.");
        }
    }


    /* **********************************************************************
     * ElementRemoteClient Methods
     * **********************************************************************/

    /**
     * Binds a remote client port of this element to a remote server port
     * using a bundle of named references. This local stub has one remote
     * client port "line" and requires the reference bundle to contain a
     * reference named "local" which can be then resolved to a true local
     * object reference.
     *
     * TODO: Handle reconfiguration.
     */
    public void bindElRemotePort (
            String portName,
            org.objectweb.dsrg.connector.RemoteRefBundle refBundle)
        throws org.objectweb.dsrg.connector.ElementLinkException {

        if ("line".equals (portName)) {
            org.objectweb.dsrg.connector.RemoteRef activeMQRef;

            activeMQRef = refBundle.getRef ("messaging");
            if (activeMQRef != null) {
            	try {
            		shutdownJMS();
            		
	            	// Create the connection.
	        		ActiveMQConnectionFactory connectionFactory = new ActiveMQConnectionFactory(ActiveMQConnection.DEFAULT_USER, ActiveMQConnection.DEFAULT_PASSWORD, ActiveMQConnection.DEFAULT_BROKER_URL);			
	        		connection = connectionFactory.createConnection();
	        		connection.start();
	
	        		// Create the session
	        		session = connection.createSession(false, Session.AUTO_ACKNOWLEDGE);
	        		
	        		Destination destination = session.createTopic(activeMQRef.stringifiedRef);	        		
	    			
	    			// Create the producer
	    			producer = session.createProducer(destination);
	        		
	    			// Create the consumer
	    			consumer = session.createConsumer(destination);
	
	                targetRemoteRef = refBundle;
	                
	                checkAndSetConsumer();
            	} catch (JMSException e) {
            		throw new org.objectweb.dsrg.connector.ElementLinkException(e);
            	}
            }
        } else {
            throw new org.objectweb.dsrg.connector.ElementLinkException (
                "Attempt to bind non-existent remote port '"+ portName +"'.");
        }
    }


    /**
     * Unbinds a given remote client port of this element
     * from a remote server port.
     *
     * TODO: Handle reconfiguration.
     */
    public void unbindElRemotePort (String portName)
        throws org.objectweb.dsrg.connector.ElementLinkException {

        if ("line".equals (portName)) {
            shutdownJMS();
            targetRemoteRef = null;
        } else {
            throw new org.objectweb.dsrg.connector.ElementLinkException (
                "Attempt to unbind non-existent remote port '"+ portName +"'.");
        }
    }


    /**
     * Queries given remote client port of this element
     * for its target reference bundle.
     */
    public org.objectweb.dsrg.connector.RemoteRefBundle getElRemoteTarget (
            String portName)
        throws org.objectweb.dsrg.connector.ElementLinkException {

        if ("line".equals (portName)) {
            return targetRemoteRef;

        } else {
            throw new org.objectweb.dsrg.connector.ElementLinkException (
                "Attempt to query target of non-existent remote port '"+ portName +"'.");
        }
    }

	public void send(Serializable message) {
		try {
			producer.send(session.createObjectMessage(message));
		} catch (JMSException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
	
	public void onMessage(Message message) {
		if (message instanceof ObjectMessage) {
			try {
				Serializable obj = ((ObjectMessage) message).getObject();
				
				if (client != null) {
					client.onMessage(obj);
				}
				
			} catch (JMSException e) {
				e.printStackTrace();
			}
		} else {
			System.out.println("Consumer: Received: " + message);
		}
	}
	
	protected void shutdownJMS ()
		throws org.objectweb.dsrg.connector.ElementLinkException {
		
		try {
			producer = null;
    		if (consumer != null) {
    			consumer.close();
    			consumer = null;
    		}
    		if (session != null)
    			session.close();
    		if (connection != null)
    			connection.close();
		} catch (JMSException e) {
			throw new org.objectweb.dsrg.connector.ElementLinkException(e);
		}
	}
	
	protected void checkAndSetConsumer()
		throws org.objectweb.dsrg.connector.ElementLinkException {
		
		if (client != null && consumer != null) {
			try {
				consumer.setMessageListener(this);
			} catch (JMSException e) {
				throw new org.objectweb.dsrg.connector.ElementLinkException(e);
			}
		}
	}
}
