package generated.A00000012;

/**
 * RMI skeleton for org.objectweb.dsrg.sofa.examples.streaming.iface.MediaServer.
 *
 * A skeleton element has a server remote port "line" through which
 * remote clients connect to the target object, which is bound to
 * the "call" required port.
 *
 * This RMI skeleton always provides "rmi" reference to itself in
 * the remote reference bundle, because it resolves connector references
 * returned instead of interface references in business methods.
 *
 * Consequently, this element never invalidates its "line" remote port.
 */
public final class RMISkeleton 
    extends java.rmi.server.UnicastRemoteObject
    implements
        org.objectweb.dsrg.connector.ElementRemoteServer,
        org.objectweb.dsrg.connector.ElementLocalClient,
        generated.A0000000Z.Interface {

    /**
     * Local target of business method invocations.
     */
    protected org.objectweb.dsrg.sofa.examples.streaming.iface.MediaServer target;

    /**
     * Instance of dock connector manager which is responsible for connector
     * units within the dock.
     */
    protected org.objectweb.dsrg.connector.mgr.DockConnectorManager dcm;

    protected org.objectweb.dsrg.connector.mgr.GlobalConnectorManager gcm;

    /**
     * Reference to parent connector unit.
     */
    protected org.objectweb.dsrg.connector.ConnectorUnit parentUnit;

    protected boolean isTopLevel;

    /**
     * Name of this element in RMI registry.
     */
    protected String regName;


    /* **********************************************************************
     * CONSTRUCTORS
     * **********************************************************************/

    public RMISkeleton (
            org.objectweb.dsrg.connector.ConnectorUnit parentUnit,
            boolean isTopLevel)
        throws
            java.rmi.RemoteException, java.net.MalformedURLException,
            org.objectweb.dsrg.connector.ElementLinkException,
            org.objectweb.dsrg.connector.mgr.ConnectorManagerException {

        this.parentUnit = parentUnit;
        this.isTopLevel = isTopLevel;

        String GCMHost = System.getProperty ("connector.gcm.rmihost");
        String GCMPort = System.getProperty ("connector.gcm.rmiport", "2008");  
        if (GCMHost == null) {
            throw new org.objectweb.dsrg.connector.mgr.ConnectorManagerException(
                "Property 'connector.gcm.rmihost' must be set to a location of Global Connector Manager.");
        }

        java.rmi.server.UID uid = new java.rmi.server.UID ();
        regName = "//" + GCMHost + ":" + GCMPort + "/connector/element/rmi/"+ uid;

        dcm = org.objectweb.dsrg.connector.mgr.
            DockConnectorManagerHelper.getDockConnectorManager ();
        gcm = org.objectweb.dsrg.connector.mgr.
            GlobalConnectorManagerHelper.getGlobalConnectorManager ();
        
        gcm.rebindConnector(regName, this);
    }


    /* **********************************************************************
     * Element Methods
     * **********************************************************************/

	public final String getElementInfo (String indent) {
		StringBuilder result = new StringBuilder ();

		result.append (indent +"Implementation: \"orig_rmi_skeleton\"\n");

		return result.toString ();
	}


    /* **********************************************************************
     * ElementLocalClient Methods
     * **********************************************************************/

    /**
     * Binds a given required port of this element to a target object using
     * a local object reference.
     */
    public void bindElPort (String portName, Object target)
        throws org.objectweb.dsrg.connector.ElementLinkException {

        if ("call".equals (portName)) {
            this.target = (org.objectweb.dsrg.sofa.examples.streaming.iface.MediaServer) target;

        } else {
            throw new org.objectweb.dsrg.connector.ElementLinkException (
                "Attempt to bind non-existent required port '"+ portName +"'.");
        }
    }


    /**
     * Unbinds a given required port of this element from its target.
     */
    public void unbindElPort (String portName)
        throws org.objectweb.dsrg.connector.ElementLinkException {

        if ("call".equals (portName)) {
            this.target = null;

        } else {
            throw new org.objectweb.dsrg.connector.ElementLinkException (
                "Attempt to unbind non-existent required port '"+ portName +"'.");
        }
    }


    /* **********************************************************************
     * ElementRemoteServer Methods
     * **********************************************************************/

    /**
     * Provides a bundle of remote references to the given remote server port.
     * Since this is an RMI skeleton, "rmi" reference is returned in the
     * reference bundle.
     */
    public org.objectweb.dsrg.connector.RemoteRefBundle lookupElRemotePort (
            String portName)
        throws org.objectweb.dsrg.connector.ElementLinkException {

        org.objectweb.dsrg.connector.RemoteRefBundle result =
            new org.objectweb.dsrg.connector.RemoteRefBundle ();

        if ("line".equals (portName)) {
            result.addRef (
                new org.objectweb.dsrg.connector.RemoteRef ("rmi", regName));

        } else {
            throw new org.objectweb.dsrg.connector.ElementLinkException (
                "Attempt to look up non-existent remote port '"+ portName +"'.");
        }

        return result;
    }


    /**
     * Returns the names of remote ports supported by this element.
     */
    public String [] listElRemotePorts () {
        return new String [] { "line" };
    }


    /* **********************************************************************
     * org.objectweb.dsrg.sofa.examples.streaming.iface.MediaServer Methods
     * **********************************************************************/

	public java.lang.String getContentInfo (java.lang.String arg0, java.lang.Object arg1) throws java.rmi.RemoteException {
		java.lang.String result;
		try {
		org.objectweb.dsrg.connector.rmi.RMIObjectDecoder rmiDecoder = new org.objectweb.dsrg.connector.rmi.RMIObjectDecoder();

		org.objectweb.dsrg.sofa.SOFAThreadHelper.setCallContext((String) arg1);

		result = this.target.getContentInfo(rmiDecoder.adaptObject(arg0));

		} catch (org.objectweb.dsrg.connector.rmi.RMIObjectAdaptorException e) {
			throw new org.objectweb.dsrg.connector.ConnectorTransportException (e);
		}
		try {
			return (new org.objectweb.dsrg.connector.rmi.RMIObjectEncoder()).adaptObject(result);
		} catch (org.objectweb.dsrg.connector.rmi.RMIObjectAdaptorException e) {
			throw new org.objectweb.dsrg.connector.ConnectorTransportException (e);
		}
	}

	public java.lang.String[] getContentList (java.lang.Object arg0) throws java.rmi.RemoteException {
		java.lang.String[] result;
		org.objectweb.dsrg.sofa.SOFAThreadHelper.setCallContext((String) arg0);

		result = this.target.getContentList();

		try {
			return (new org.objectweb.dsrg.connector.rmi.RMIObjectEncoder()).adaptObject(result);
		} catch (org.objectweb.dsrg.connector.rmi.RMIObjectAdaptorException e) {
			throw new org.objectweb.dsrg.connector.ConnectorTransportException (e);
		}
	}


}
