package generated.A0000001K;

/**
 * Local stub for org.ow2.dsrg.sofa.examples.script.logdemo.iface.Log.
 *
 * A stub element has a client remote port "line" through which
 * it connects to the target object. When binding the "line" port
 * to a remote target using a bundle of references, a local stub
 * is only interested in the "local" reference.
 *
 * TODO: call reconfiguration handler when the target references change.
 */
public final class LocalStub 
    implements
        org.objectweb.dsrg.connector.ElementLocalServer,
        org.objectweb.dsrg.connector.ElementRemoteClient,
        org.objectweb.dsrg.connector.ReconfigurableElement,
        org.ow2.dsrg.sofa.examples.script.logdemo.iface.Log {

    /**
     * Local target of business method invocations.
     */
    protected org.ow2.dsrg.sofa.examples.script.logdemo.iface.Log target;

    /**
     * A bundle of remote references to the target of business method
     * invocations.
     */
    protected org.objectweb.dsrg.connector.RemoteRefBundle targetRemoteRef;

    /*
     * Instance of dock connector manager which is responsible for connector
     * units within the dock.
     */
    protected org.objectweb.dsrg.connector.mgr.DockConnectorManager dcm;

    /*
     * Reference to parent connector unit.
     */
    protected org.objectweb.dsrg.connector.ConnectorUnit parentUnit;

    protected boolean isTopLevel;

    /**
     * Reconfiguration request handler.
     */
    protected org.objectweb.dsrg.connector.ReconfigurationHandler reconfigurationHandler;


    /* **********************************************************************
     * CONSTRUCTORS
     * **********************************************************************/

    /**
     * Constructs a new local stub element.
     */
    public LocalStub (
            org.objectweb.dsrg.connector.ConnectorUnit parentUnit,
            boolean isTopLevel) {

        this.parentUnit = parentUnit;
        this.isTopLevel = isTopLevel;

        dcm = org.objectweb.dsrg.connector.mgr.
            DockConnectorManagerHelper.getDockConnectorManager();
    }


    /* **********************************************************************
     * Element Methods
     * **********************************************************************/

	public final String getElementInfo (String indent) {
		StringBuilder result = new StringBuilder ();

		result.append (indent +"Implementation: \"orig_local_stub\"\n");

		return result.toString ();
	}


    /**
     * Sets the reconfiguration handler.
     */
    public final void setElReconfigurationHandler (
        org.objectweb.dsrg.connector.ReconfigurationHandler reconfigurationHandler) {

        this.reconfigurationHandler = reconfigurationHandler;
    }


    /* **********************************************************************
     * ElementLocalServer Methods
     * **********************************************************************/

    /**
     * Queries given provided port for a local object reference.
     */
    public Object lookupElPort (String portName)
        throws org.objectweb.dsrg.connector.ElementLinkException {

        if ("call".equals (portName)) {
            Object portReference;

            if (target == null) {
                /*
                 * If the element is not yet bound to the target object,
                 * return a reference to itself. This will cause all
                 * invocations of target object methods to pass through
                 * this element, where they can be delayed.
                 */
                portReference = this;

            } else {
                portReference = target;
            }

            if (isTopLevel) {
                dcm.reregisterConnectorUnitReference (
                    parentUnit, "call", portReference);
            }

            return portReference;

        } else {
            throw new org.objectweb.dsrg.connector.ElementLinkException (
                "Attempt to look up non-existent provided port '"+ portName +"'.");
        }
    }


    /* **********************************************************************
     * ElementRemoteClient Methods
     * **********************************************************************/

    /**
     * Binds a remote client port of this element to a remote server port
     * using a bundle of named references. This local stub has one remote
     * client port "line" and requires the reference bundle to contain a
     * reference named "local" which can be then resolved to a true local
     * object reference.
     *
     * TODO: Handle reconfiguration.
     */
    public void bindElRemotePort (
            String portName,
            org.objectweb.dsrg.connector.RemoteRefBundle refBundle)
        throws org.objectweb.dsrg.connector.ElementLinkException {

        if ("line".equals (portName)) {
            org.objectweb.dsrg.connector.RemoteRef localRef;

            localRef = refBundle.getRef ("local");
            if (localRef != null) {
                target = (org.ow2.dsrg.sofa.examples.script.logdemo.iface.Log) org.objectweb.dsrg.connector.
                    LocalReferenceRegistry.unstringify (localRef.stringifiedRef);

                targetRemoteRef = refBundle;

            } else {
                target = null;
            }

        } else {
            throw new org.objectweb.dsrg.connector.ElementLinkException (
                "Attempt to bind non-existent remote port '"+ portName +"'.");
        }
    }


    /**
     * Unbinds a given remote client port of this element
     * from a remote server port.
     *
     * TODO: Handle reconfiguration.
     */
    public void unbindElRemotePort (String portName)
        throws org.objectweb.dsrg.connector.ElementLinkException {

        if ("line".equals (portName)) {
            target = null;
            targetRemoteRef = null;

        } else {
            throw new org.objectweb.dsrg.connector.ElementLinkException (
                "Attempt to unbind non-existent remote port '"+ portName +"'.");
        }
    }


    /**
     * Queries given remote client port of this element
     * for its target reference bundle.
     */
    public org.objectweb.dsrg.connector.RemoteRefBundle getElRemoteTarget (
            String portName)
        throws org.objectweb.dsrg.connector.ElementLinkException {

        if ("line".equals (portName)) {
            return targetRemoteRef;

        } else {
            throw new org.objectweb.dsrg.connector.ElementLinkException (
                "Attempt to query target of non-existent remote port '"+ portName +"'.");
        }
    }


    /* **********************************************************************
     * org.ow2.dsrg.sofa.examples.script.logdemo.iface.Log Methods
     * **********************************************************************/

	public void log (java.lang.String arg0) {
this.target.log (arg0);
		return;
	}


}
