package org.objectweb.dsrg.sofa.examples.logaspect;

public interface MILog {
  /** Event class. */
  public enum Event {
    CALL, RETURN
  }
  /** Event type. */
  public enum Type {
    BUSSINESS, CONTROL
  }
  /** Point of view. */
  public enum View {
    CALLER, CALLEE, UNSPECIFIED
  }
  
  /** Log method call or return.
    * 
    * @param componenetDescription describes component where the event triggered
    * @param event which event is logged (call/return)
    * @param eventType type of event (bussiness, control)
    * @param eventView which point of view is the event being observed from (caller, callee side)
    * @param method textual representation of method being logged
    */
  public void log(String componenetDescription, Event event, Type eventType , View eventView, String method);
}
