/* $Id$
 *
 * SOFA 2.0 component system
 * Copyright (C) 2006-2010  DDDS, Charles University in Prague
 *                          http://d3s.mff.cuni.cz/
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA 02110-1301 USA
 *
 */
package org.ow2.dsrg.sofa.aspects.script;

import java.lang.reflect.Method;


/**
 * Interface for receiving script interceptor notifications.
 * 
 *  @author Jaroslav Keznikl
 */
public interface MIScriptInterceptor {
	
	/**
	 * Invoked when the intercepted method is called.
	 * @param methodSignature	byte-code signature of the method that has been called
	 * @param interfaceClass	byte-code description of the intercepted interface
	 * @param params	parameters of the method call
	 * @throws Exception	  
	 */
	Object notifyCall(String methodSignature, String interfaceClass, Object[] params) throws Exception;
}
