# $Id$
#
# SOFA 2.0 component system
# Copyright (C) 2006-2010  DDDS, Charles University in Prague
#                          http://d3s.mff.cuni.cz/
#
# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public
# License along with this library; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
# MA 02110-1301 USA
#
#

###############################################################################
# This file contains the implementation of the
# org.ow2.dsrg.sofa.examples.script.logdemo.arch.Log architecture
#
# @author Jaroslav Keznikl
###############################################################################

# load the current code bundle on the Jython system path so that it could be 
# searched for Python modules 
SOFAPythonImporter.loadCurrentCodeBundle()

# import the helper class for logging (test the Python importing support)
from org.ow2.dsrg.sofa.examples.script.logdemo.arch.Printer import LogPrinter

# import a script file from the 'Common' code bundle 
# (test the generic importing support)
SOFAScriptImporter.importFile("import-test/test.py")

# create new instance of the helper class
printer = LogPrinter()

# Implementation of the method
# org.ow2.dsrg.sofa.examples.script.logdemo.iface.Log#log(String).
#
# Uses the helper class to log the given message.  
def log(message):
    printer.printLog(message)    
