/* $Id$
 *
 * SOFA 2.0 component system
 * Copyright (C) 2006-2010  DDDS, Charles University in Prague
 *                          http://d3s.mff.cuni.cz/
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA 02110-1301 USA
 *
 */

/******************************************************************************
 * This file contains the implementation of the
 * org.ow2.dsrg.sofa.examples.script.logdemo.arch.LogEx architecture
 * 
 * @author Jaroslav Keznikl
 *****************************************************************************/

// import the library file from the given code bundle (test the import mechanism)
SOFAScriptImporter.importFile("jslib/log_lib.js", "org.ow2.dsrg.sofa.examples.script.logdemo.cbundle.Common")

// initialize current log level
var m_logLevel = 10;

/**
 * Implementation of the method
 * {@ link org.ow2.dsrg.sofa.examples.script.logdemo.iface.LogEx#log(int, String)}.
 * @param logLevel	the current log level
 * @param message	the message to be logged
 * @returns	number of characters of the logged message
 */
function log(logLevel, message) {	
	if (shouldLog(logLevel, m_logLevel)) { 
		logger.log(message);
	}	
	return message.length;
}


