package org.ow2.dsrg.sofa.examples.script.logdemo.arch;
import org.objectweb.dsrg.sofa.SOFAClient;
import org.objectweb.dsrg.sofa.SOFALifecycle;
import org.objectweb.dsrg.sofa.SOFAThreadHelper;
import org.ow2.dsrg.sofa.examples.script.logdemo.cbundle.Common.LogDisabledException;
import org.ow2.dsrg.sofa.examples.script.logdemo.iface.LogEx;

public class TesterBackup implements SOFALifecycle, Runnable, SOFAClient {
  
  boolean end = false;
  LogEx logger = null;

  // Implements method from the SOFALifecycle interface.
  // Called during instantiation of the component.
  public void start() {
    Thread t = new Thread(this);
    t.start();
  }

  // Implements method from the SOFALifecycle interface.
  // Called as a notification that component will be stopped
  public void stopping() {
  }

  // Implements method from the SOFALifecycle interface.
  // Called during stopping of the component
  public void stop() {
    end = true;
  }

  // Thread of the component (java.lang.Runnable interface)
  public void run() {
    while (!end) {
      int a;
      try {
      a = logger.log(0, "Hello world from Java on level 0");
      a += logger.log(1, "Hello world from Java on level 1");
      a += logger.log(2, "Hello world from Java on level 2");
      } catch (LogDisabledException e) {
    	  e.printStackTrace();
    	  return;
      }
      System.out.println("Total: " + a);
      try {
        Thread.sleep(5000);
      } catch (Exception e) {}
    }
  }
  
  // Implements method from the SOFAClient interface
  // Called during initialization of the component
  public void setRequired(String name, Object iface) {
    if (name.equals("logEx")) {
      if (iface instanceof LogEx) {
        logger = (LogEx) iface;
      }
    }
  }
}
