/* $Id$
 *
 * SOFA 2.0 component system
 * Copyright (C) 2006-2010  DDDS, Charles University in Prague
 *                          http://d3s.mff.cuni.cz/
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA 02110-1301 USA
 *
 */
package org.ow2.dsrg.sofa.examples.script.logdemo.iface;

import org.ow2.dsrg.sofa.examples.script.logdemo.cbundle.Common.LogDisabledException;

/**
 * Extended logging interface. Filters messages according to the selected log level.
 * 
 * @author Jaroslav Keznikl
 */
public interface LogEx {  
	/**
	 * Log the given message on the given log level.
	 * @param logLevel	log level of the message
	 * @param message	text of the message
	 * @return	number of logged characters
	 * @throws LogDisabledException if the logging is disabled for the given log level
	 */
	int log(int logLevel, String message) throws LogDisabledException;
}
