#!/bin/bash

# Name of the SOFAnode. Default is host name.
# Set it if the default is not sufficient.
#SOFANODENAME="foo.bar.org"

# Directory to which all logs are stored.
# Usually not necessary to change.
SOFALOGDIR="$SOFA_HOME/_logs"
SOFALOGPORT="8172"

# Log4j configuration files for particular commands.
# Usually not necessary to change.
REGLOGCONF="$SOFA_HOME/conf/registry-log4j.properties"
REPLOGCONF="$SOFA_HOME/conf/repository-log4j.properties"
CONMANLOGCONF="$SOFA_HOME/conf/conman-log4j.properties"
DOCKLOGCONF="$SOFA_HOME/conf/dock-log4j.properties"
LAUNCHLOGCONF="$SOFA_HOME/conf/launch-log4j.properties"
SHUTLOGCONF="$SOFA_HOME/conf/shut-log4j.properties"
PSLOGCONF="$SOFA_HOME/conf/ps-log4j.properties"
CAPSLOGCONF="$SOFA_HOME/conf/caps-log4j.properties"
NODELOGCONF="$SOFA_HOME/conf/node-log4j.properties"

# Directory where the repository stores its content.
# It must be set on a computer, where the repository is executed. On other
# computers it has no meaning.
# Usually not necessary to change.
SOFAREPOSITORYPATH="$SOFA_HOME/_repdir"

# Context of the repository.
# Usually, no need to change.
# Must be set on all machines, which connect themselves to the repository.
# That means on all computers which are running dock registry, docks or
# machines used to launch and shut down applications. The only machine, that
# does *not* take this setting into account is the repository server.
# Please set the context when launching the server in warfile/WEB-INF/web.xml.
SOFAREPCONTEXT="/SofaServlet"

# OSGi configuration
FELIXCONF="$SOFA_HOME/conf/felix-osgi-config.properties"
FELIXCACHE="$SOFA_HOME/_osgi_cache"
BUNDLES="$SOFA_HOME/lib/externals/bundles"

# Zeroconf server configuration
ZEROCONFPORT="6789"
