#!/bin/bash

if [ $# -ne 1 -a $# -ne 2 ]; then
        echo "Usage: sofa-dockosgi.sh name-of-the-dock [osgi-property-file]"
  exit 1
fi

PRG="$0"

PRGDIR=`dirname "$PRG"`

SOFA_HOME=$PRGDIR/..

if [ -r "$PRGDIR"/setenv.sh ]; then
  . "$PRGDIR"/setenv.sh
fi

SOFACLASSPATH="$SOFA_HOME/lib/asm-asm-3.2.jar:$SOFA_HOME/lib/asm-asm-commons-3.2.jar:$SOFA_HOME/lib/asm-asm-util-3.2.jar:$SOFA_HOME/lib/com.google.collections-google-collections-1.0.jar:$SOFA_HOME/lib/com.google.inject-guice-2.0.jar:$SOFA_HOME/lib/commons-codec-commons-codec-1.4.jar:$SOFA_HOME/lib/commons-collections-commons-collections-3.2.1.jar:$SOFA_HOME/lib/commons-fileupload-commons-fileupload-1.2.1.jar:$SOFA_HOME/lib/commons-httpclient-commons-httpclient-3.1.jar:$SOFA_HOME/lib/commons-io-commons-io-1.4.jar:$SOFA_HOME/lib/commons-lang-commons-lang-2.5.jar:$SOFA_HOME/lib/commons-logging-commons-logging-1.1.1.jar:$SOFA_HOME/lib/javax.servlet-servlet-api-2.5.jar:$SOFA_HOME/lib/junit-junit-4.8.1.jar:$SOFA_HOME/lib/log4j-log4j-1.2.16.jar:$SOFA_HOME/lib/org.apache.felix-org.apache.felix.main-1.0.0.jar:$SOFA_HOME/lib/org.apache.velocity-velocity-1.6.4.jar:$SOFA_HOME/lib/org.eclipse.emf-org.eclipse.emf.common-2.6.0.v20100614-1136.jar:$SOFA_HOME/lib/org.eclipse.emf-org.eclipse.emf.ecore-2.6.0.v20100614-1136.jar:$SOFA_HOME/lib/org.eclipse.emf-org.eclipse.emf.ecore.xmi-2.5.0.v20100521-1846.jar:$SOFA_HOME/lib/org.eclipse.jetty-jetty-continuation-7.1.4.v20100610.jar:$SOFA_HOME/lib/org.eclipse.jetty-jetty-http-7.1.4.v20100610.jar:$SOFA_HOME/lib/org.eclipse.jetty-jetty-io-7.1.4.v20100610.jar:$SOFA_HOME/lib/org.eclipse.jetty-jetty-security-7.1.4.v20100610.jar:$SOFA_HOME/lib/org.eclipse.jetty-jetty-server-7.1.4.v20100610.jar:$SOFA_HOME/lib/org.eclipse.jetty-jetty-servlet-7.1.4.v20100610.jar:$SOFA_HOME/lib/org.eclipse.jetty-jetty-util-7.1.4.v20100610.jar:$SOFA_HOME/lib/org.eclipse.jetty-jetty-webapp-7.1.4.v20100610.jar:$SOFA_HOME/lib/org.eclipse.jetty-jetty-xml-7.1.4.v20100610.jar:$SOFA_HOME/lib/org.jdom-jdom-1.1.jar:$SOFA_HOME/lib/org.objectweb.dsrg-congen-0.7.2.jar:$SOFA_HOME/lib/org.objectweb.dsrg-sofa-commons-0.8.1-local-20111231122041.jar:$SOFA_HOME/lib/org.objectweb.dsrg-sofa-dock-0.8.1-local-20111231122046.jar:$SOFA_HOME/lib/org.objectweb.dsrg-sofa-dockregistry-0.8.1-local-20111231122135.jar:$SOFA_HOME/lib/org.objectweb.dsrg-sofa-fm-commons-0.8.1-local-20111231122135.jar:$SOFA_HOME/lib/org.objectweb.dsrg-sofa-j-autoconf-0.8.1-local-20111231122150.jar:$SOFA_HOME/lib/org.objectweb.dsrg-sofa-j-bootstrap-0.8.1-local-20111231122152.jar:$SOFA_HOME/lib/org.objectweb.dsrg-sofa-j-component-api-0.8.1-local-20111231122144.jar:$SOFA_HOME/lib/org.objectweb.dsrg-sofa-j-dock-0.8.1-local-20111231122144.jar:$SOFA_HOME/lib/org.objectweb.dsrg-sofa-j-repository-0.8.1-local-20111231122153.jar:$SOFA_HOME/lib/org.objectweb.dsrg-sofa-repository-0.8.1-local-20111231122114.jar:$SOFA_HOME/lib/org.objectweb.dsrg-sofa-repository-server-0.8.1-local-20111231122047.jar:$SOFA_HOME/lib/org.objectweb.dsrg-sofa-repository-server-api-0.8.1-local-20111231122047.jar:$SOFA_HOME/lib/org.objectweb.dsrg-sofa-tools-api-0.8.1-local-20111231122140.jar"

if [ ! -z "$2" ]; then
        FELIXCONF="$2"
fi

# DEBUG
DEBUG_ENABLED=false
if [ "$DEBUG_ENABLED" == "true" ]; then
  DEBUG="-Xdebug -Xrunjdwp:transport=dt_socket,address=8456,server=y,suspend=n"
else
  DEBUG=
fi
# end of debug

java -cp $SOFACLASSPATH -Djava.security.policy="$SOFA_HOME/.java.policy" -Dsofa.logdir="$SOFALOGDIR" -Dsofa.logfile="dock-${1}.log" -Dlog4j.configuration="file:$DOCKLOGCONF" -Dsofa.registry.port="$SOFARMIPORT" -Dsofa.registry.host="$SOFARMIHOST" -Djava.rmi.server.hostname="$SOFARMIHOST" -Dconnector.gcm.rmihost="$SOFACONMANHOST" -Dsofa.agent.repository.hostname="$SOFAREPHOST" -Dsofa.agent.repository.port="$SOFAREPPORT" -Dsofa.agent.repository.context="$SOFAREPCONTEXT" -Dosgi.bundles="$BUNDLES" -Dfelix.cache.profiledir="$FELIXCACHE" -Dfelix.config.properties="file:$FELIXCONF" -Dsofa.dock.capabilities=OSGi $DEBUG org.objectweb.dsrg.sofa.deployment.util.RunDeploymentDock $1
